Imports System
Imports System.Drawing
Imports System.Collections
Imports System.ComponentModel
Imports System.Windows.Forms
Imports System.Data

Imports Syncfusion.Windows.Forms.Grid.Grouping
Imports Syncfusion.Grouping
Imports Syncfusion.Windows.Forms.Grid

Public Class Form1

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Dim parentTable As List(Of ParentTable) = GetParentTable()
        Dim childTable As List(Of ChildTable) = GetChildTable()

        '' ###########################
        ''''''''''''' WHEN THIS IS ADDED, THE 4th COLUMN WITH DROPDOWN DOES NOT APPEAR
        '' ###########################
        Dim c1, c2, c3, c4 As GridColumnDescriptor

        c1 = New GridColumnDescriptor
        c2 = New GridColumnDescriptor
        c3 = New GridColumnDescriptor
        c4 = New GridColumnDescriptor

        c1.HeaderText = "ParentID"
        c2.HeaderText = "ParentName"
        c3.HeaderText = "ForeignCategoryID"
        c4.HeaderText = "ForeignInsideCategoryID"

        c1.MappingName = "ParentID"
        c2.MappingName = "ParentName"
        c3.MappingName = "ForeignCategoryID"
        c4.MappingName = "ForeignInsideCategoryID"

        gridGroupingControl1.TableDescriptor.Columns.Add(c1)
        gridGroupingControl1.TableDescriptor.Columns.Add(c2)
        gridGroupingControl1.TableDescriptor.Columns.Add(c3)
        gridGroupingControl1.TableDescriptor.Columns.Add(c4)
        '' ###########################
        ''''''''''''''''''
        '' ###########################

        Dim parentToChildRelationDescriptor As New GridRelationDescriptor()
        parentToChildRelationDescriptor.Name = "ChildTable"
        parentToChildRelationDescriptor.ChildTableName = "MyChildTable123"
        parentToChildRelationDescriptor.RelationKind = RelationKind.ForeignKeyReference
        parentToChildRelationDescriptor.RelationKeys.Add("ForeignCategoryID", "CategoryID")
        parentToChildRelationDescriptor.RelationKeys.Add("ForeignInsideCategoryID", "InsideCategoryID")

        gridGroupingControl1.TableDescriptor.Relations.Add(parentToChildRelationDescriptor)

        Me.gridGroupingControl1.Engine.SourceListSet.Add("ParentTable", parentTable)
        Me.gridGroupingControl1.Engine.SourceListSet.Add("MyChildTable123", childTable)

        'Me.gridGroupingControl1.Name = "ParentTable"
        Me.gridGroupingControl1.DataSource = parentTable

        Me.gridGroupingControl1.TableOptions.GridVisualStyles = Syncfusion.Windows.Forms.GridVisualStyles.Office2007Blue
         Me.gridGroupingControl1.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = False
        Me.gridGroupingControl1.TopLevelGroupOptions.ShowCaption = False
        Me.BackColor = Color.FromArgb(223, 227, 239)

    End Sub

    Private numberParentRows As Integer = 25
    Private numberChildRows As Integer = 20


    Private Function GetParentTable() As List(Of ParentTable)
        Dim dt As New List(Of ParentTable)


        Dim i As Integer
        For i = 0 To numberParentRows - 1
            Dim dr As ParentTable = New ParentTable
            dr.ParentID = i '.ToString();
            dr.ParentName = String.Format("parentName{0}", i)
            dr.ForeignCategoryID = Int(i / 5)
            dr.ForeignInsideCategoryID = i Mod 5
            dt.Add(dr)
        Next i

        Return dt
    End Function 'GetParentTable


    Private Function GetChildTable() As List(Of ChildTable)
        Dim dt As New List(Of ChildTable)

        Dim i As Integer
        For i = 0 To numberChildRows - 1
            Dim dr As ChildTable = New ChildTable
            dr.CategoryID = Int(i / 5).ToString()
            dr.InsideCategoryID = (i Mod 5).ToString()
            dr.CategoryChildName = String.Format("ChildName{0}", i)
            dt.Add(dr)
        Next i

        Return dt
    End Function 'GetChildTable

End Class

Class ParentTable

    Private _parentID As Integer
    Private _parentName As String
    Private _foreignCategoryID As Integer
    Private _foreignInsideCategoryID As Integer

    Public Property ParentID() As Integer
        Get
            Return _parentID
        End Get
        Set(ByVal value As Integer)
            _parentID = value
        End Set
    End Property

    Public Property ParentName() As String
        Get
            Return _parentName
        End Get
        Set(ByVal value As String)
            _parentName = value
        End Set
    End Property

    Public Property ForeignCategoryID() As Integer
        Get
            Return _foreignCategoryID
        End Get
        Set(ByVal value As Integer)
            _foreignCategoryID = value
        End Set
    End Property

    Public Property ForeignInsideCategoryID() As Integer
        Get
            Return _foreignInsideCategoryID
        End Get
        Set(ByVal value As Integer)
            _foreignInsideCategoryID = value
        End Set
    End Property

End Class

Public Class ChildTable

    Private _categoryID As Integer
    Private _insideCategoryID As Integer
    Private _categoryChildName As String

    Public Property CategoryID() As Integer
        Get
            Return _categoryID
        End Get
        Set(ByVal value As Integer)
            _categoryID = value
        End Set
    End Property

    Public Property InsideCategoryID() As Integer
        Get
            Return _insideCategoryID
        End Get
        Set(ByVal value As Integer)
            _insideCategoryID = value
        End Set
    End Property

    Public Property CategoryChildName() As String
        Get
            Return _categoryChildName
        End Get
        Set(ByVal value As String)
            _categoryChildName = value
        End Set
    End Property

End Class