Imports System
Imports System.Drawing
Imports System.Collections
Imports System.ComponentModel
Imports System.Windows.Forms
Imports System.Data

Imports Syncfusion.Windows.Forms.Grid.Grouping
Imports Syncfusion.Grouping
Imports Syncfusion.Windows.Forms.Grid

Public Class Form1

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Dim parentTable As List(Of ParentTable) = GetParentTable()

        ' Parent column
        Dim c1, c2 As GridColumnDescriptor

        c1 = New GridColumnDescriptor
        c2 = New GridColumnDescriptor

        c1.HeaderText = "ID"
        c2.HeaderText = "Name"

        c1.MappingName = "ID"
        c2.MappingName = "Name"

        gridGroupingControl1.TableDescriptor.Columns.Add(c1)
        gridGroupingControl1.TableDescriptor.Columns.Add(c2)

        ' Relation
        Dim relation As Syncfusion.Windows.Forms.Grid.Grouping.GridRelationDescriptor

        gridGroupingControl1.TableDescriptor.Relations.Clear()

        relation = New Syncfusion.Windows.Forms.Grid.Grouping.GridRelationDescriptor()
        relation.RelationKind = Syncfusion.Grouping.RelationKind.UniformChildList
        relation.MappingName = "Childs"
        relation.Name = "Childs"
        relation.ChildTableName = "Childs"
        gridGroupingControl1.TableDescriptor.Relations.Add(relation)

        ' Child column
        c1 = New GridColumnDescriptor
        c2 = New GridColumnDescriptor

        c1.HeaderText = "ID"
        c2.HeaderText = "Name"

        c1.MappingName = "ID"
        c2.MappingName = "Name"

        gridGroupingControl1.GetTableDescriptor("Childs").Columns.Add(c1)
        gridGroupingControl1.GetTableDescriptor("Childs").Columns.Add(c2)

        ' Other
        Me.gridGroupingControl1.Name = "ParentTable"
        Me.gridGroupingControl1.AutoPopulateRelations = False

        ' Bind
        Me.gridGroupingControl1.DataSource = parentTable

        ' The problem is where
        If gridGroupingControl1.GetTableModel("Childs") Is Nothing Then
            MessageBox.Show("Nothing")
        Else
            MessageBox.Show("Something")
        End If

    End Sub

    Public Function GetParentTable() As List(Of ParentTable)

        Dim ret As List(Of ParentTable)

        ret = New List(Of ParentTable)
        ret.Add(New ParentTable(1, "P1"))
        ret.Add(New ParentTable(2, "P2"))
        ret.Add(New ParentTable(3, "P3"))

        Return ret
    End Function

End Class